Magellan Linux

Diff of /branches/mage-next/src/smage2.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 1081 by niro, Mon Jun 28 17:47:38 2010 UTC revision 1659 by niro, Sat Jan 14 00:01:52 2012 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3    
4  # compiles/installs .smage2 source install scripts  # compiles/installs .smage2 source install scripts
5  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
6    
7  # SMAGE2  # TODO: record dynlib, gz | xz database
 # $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.62 2007-11-28 10:47:50 niro Exp $  
8    
 #01.10.2004  
 # added ccache support  
 # added distcc support  
9    
10  # set default user mage.rc  # set default user mage.rc
11  : ${MAGERC="/etc/mage.rc"}  : ${MAGERC="/etc/mage.rc"}
12    
 ## setup ##  
 PKGSUFFIX="mpk"  
 SRCPKGSUFFIX="mpks"  
 SMAGENAME="$1"  
 SMAGESUFFIX="smage2"  
 MLIBDIR=/usr/lib/mage  
 SMAGEVERSION="$( < ${MLIBDIR}/version)"  
   
 ## only for tests -> normally in /etc/rc.d/init.d/functions  
 COLRED="\033[1;6m\033[31m"  
 COLGREEN="\033[1;6m\033[32m"  
 COLYELLOW="\033[1;6m\033[33m"  
 COLBLUE="\033[1;6m\033[34m"  
 COLMAGENTA="\033[1;6m\033[35m"  
 COLWHITE="\033[1;6m\033[37m"  
 COLGRAY="\033[0;6m\033[37m"  
 COLBOLD="\033[1m"  
 COLDEFAULT="\033[0m"  
   
 if [[ ${NOCOLORS} = true ]]  
 then  
  COLRED=""  
  COLGREEN=""  
  COLYELLOW=""  
  COLBLUE=""  
  COLMAGENTA=""  
  COLWHITE=""  
  COLGRAY=""  
  COLBOLD=""  
  COLDEFAULT=""  
 fi  
   
13  # export default C locale  # export default C locale
14  export LC_ALL=C  export LC_ALL=C
15    
16  source /etc/mage.rc.global  source /etc/mage.rc.global
17  source ${MAGERC}  source ${MAGERC}
18    source ${MLIBDIR}/mage4.functions.sh
19    source ${MLIBDIR}/smage2.functions.sh
20    
21  # set PKGDIR and BUILDDIR and BINDIR to MROOT  ## setup ##
22    SMAGENAME="$1"
23    SMAGEVERSION="$(< ${MLIBDIR}/version)"
24    
25    # expand PKGDIR, BUILDDIR and BINDIR with MROOT
26  if [[ -n ${MROOT} ]]  if [[ -n ${MROOT} ]]
27  then  then
28   export PKGDIR=${MROOT}/${PKGDIR}   export PKGDIR=${MROOT}/${PKGDIR}
# Line 59  then Line 30  then
30   export BINDIR=${MROOT}/${BINDIR}   export BINDIR=${MROOT}/${BINDIR}
31  fi  fi
32    
 showversion()  
 {  
  echo -en "Magellan Source Install v${SMAGEVERSION} "  
  echo -e  "-- Niels Rogalla (niro@magellan-linux.de)"  
 }  
   
 die()  
 {  
  xtitleclean  
  echo -e ${COLRED}"Exited ${BASH_SOURCE} at line no ${BASH_LINENO}."${COLDEFAULT}  
  echo "SMAGE failed: $@"  
  exit 1  
 }  
   
 die_pipestatus()  
 {  
  # the status change if we do any parameter declarations!!  
  # dont do this anymore, keep this in mind!  
  #  
  # local pos="$1"  
  # local comment="$2"  
  #  
  # [ ${PIPESTATUS[${pos}]} -ne 0 ] && die "${comment}"  
  #  
  [ ${PIPESTATUS[$1]} -ne 0 ] && die "$2"  
 }  
   
 xtitle()  
 {  
  if [[ ${TERM} = xterm ]]  
  then  
  echo -ne "\033]0;[sMage: $@]\007"  
  fi  
  return 0  
 }  
   
 xtitleclean()  
 {  
  if [[ ${TERM} = xterm ]]  
  then  
  echo -ne "\033]0;\007"  
  fi  
  return 0  
 }  
   
 syncsmage2()  
 {  
  xtitle "Updating smage2-script tree ..."  
  local i  
  for i in ${SMAGE2RSYNC}  
  do  
  rsync ${RSYNC_FETCH_OPTIONS} ${i} ${SMAGESCRIPTSDIR}  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  done  
   
  # clean up backup files (foo~)  
  find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'  
   
  xtitleclean  
 }  
   
 # $1 filename  
 get_db_md5_sum()  
 {  
  local DB_FILE  
  local MD5_FILE  
  local i  
   
  DB_ENTRY="$(basename $1)"  
  MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} ${SMAGESUFFIX})"  
   
  i="$(cat ${MD5_FILE}| grep ${DB_ENTRY} | cut -d' ' -f1)"  
   
  echo "${i}"  
 }  
   
 download_sources()  
 {  
   
  [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0  
   
  local EOA=${#SRC_URI[*]}  
  local my_SRC_URI  
  local my_SRC_URI_DEST  
  local my_SRC_URI_MIRROR  
  local my_SOURCEDIR  
  local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"  
  local FETCHING  
  local i mirror  
   
   
  # install SRCDIR/PNAME if not exist  
  [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}  
   
  # check if FETCHING is needed  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} &> /dev/null )  
  if [[ $? = 0 ]]  
  then  
  # md5's ok, no fetching needed  
  FETCHING=false  
  else  
  FETCHING=true  
  fi  
   
  for ((i=0; i < EOA; i++))  
  do  
  # url to file  
  my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"  
   
  # subdir in sources dir; the my_SRCI_URI file goes to there  
  my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"  
   
  # if my_src_uri_dest is not equal my_src_uri; than an other dir is used  
  if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]  
  then  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}/${my_SRC_URI_DEST}"  
  else  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}"  
  fi  
   
  # create the SOURCEDIR  
  install -d ${my_SOURCEDIR}  
   
  # if an mirrored file than replace first the mirror uri  
  if [[ -n $(echo ${my_SRC_URI} | grep 'mirror://') ]]  
  then  
  for mirror in ${MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|mirror:/|${mirror}/sources|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'sourceforge://') ]]  
  then  
  for mirror in ${SOURCEFORGE_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|sourceforge:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'gnu://') ]]  
  then  
  for mirror in ${GNU_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|gnu:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'kde://') ]]  
  then  
  for mirror in ${KDE_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|kde:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'gnome://') ]]  
  then  
  for mirror in ${GNOME_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|gnome:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  else  
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI})" \  
  "${my_SRC_URI}"  
  fi  
  fi  
   
  # unset them to be shure  
  unset my_SRC_URI  
  unset my_SRC_URI_DEST  
  unset my_SRC_URI_MIRROR  
  unset my_SOURCEDIR  
  done  
   
  # recheck md5 sums  
  echo  
  echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} ) || die "md5 failed"  
  echo  
   
  # not needed anymore  
  unset SRC_URI  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_prepare()  
 {  
  echo "no src_prepare defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_compile()  
 {  
  echo "no src_compile defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_install()  
 {  
  echo "no src_install defined"  
  sleep 2  
  return 0  
 }  
   
 mlibdir()  
 {  
  local libdir=lib  
  [[ ${ARCH} = x86_64 ]] && libdir=lib64  
   
  echo "${libdir}"  
 }  
   
 mconfigure()  
 {  
  if [ -x ./configure ]  
  then  
  ./configure \  
  --prefix=/usr \  
  --host=${CHOST} \  
  --build=${CHOST} \  
  --mandir=/usr/share/man \  
  --infodir=/usr/share/info \  
  --datadir=/usr/share \  
  --sysconfdir=/etc \  
  --localstatedir=/var/lib \  
  --libdir=/usr/$(mlibdir) \  
  "$@" || die "mconfigure failed"  
  else  
  echo "configure is not an executable ..."  
  exit 1  
  fi  
 }  
   
 minstall()  
 {  
  if [ -f ./[mM]akefile -o -f ./GNUmakefile ]  
  then  
  make prefix=${BINDIR}/usr \  
  datadir=${BINDIR}/usr/share \  
  infodir=${BINDIR}/usr/share/info \  
  localstatedir=${BINDIR}/var/lib \  
  mandir=${BINDIR}/usr/share/man \  
  sysconfdir=${BINDIR}/etc \  
  libdir=${BINDIR}/usr/$(mlibdir) \  
  "$@" install || die "minstall failed"  
         else  
                 die "no Makefile found"  
         fi  
 }  
   
 mmake()  
 {  
  make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"  
 }  
   
 munpack()  
 {  
  local SRCFILE  
  local IFTAR  
  local DEST  
   
  SRCFILE=$1  
   
  if [[ -z $2 ]]  
  then  
  DEST=${BUILDDIR}  
  else  
  DEST=$2  
  fi  
   
  [[ ! -d ${DEST} ]] && install -d ${DEST}  
   
  case "${SRCFILE##*.}" in  
  bz2)  
  IFTAR="$(basename $SRCFILE .bz2)"  
  IFTAR="${IFTAR##*.}"  
  if [[ ${IFTAR} = tar ]]  
  then  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.bz2 unpack failed."  
  else  
  pushd ${DEST} > /dev/null  
  bzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .bz2) || die ".bz2 unpack failed."  
  popd > /dev/null  
  fi  
  ;;  
  gz)  
  IFTAR="$(basename $SRCFILE .gz)"  
  IFTAR="${IFTAR##*.}"  
  if [[ ${IFTAR} = tar ]]  
  then  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.gz unpack failed."  
  else  
  pushd ${DEST} > /dev/null  
  zcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .gz) || die ".gz unpack failed."  
  popd > /dev/null  
  fi  
  ;;  
  tbz2|mpks|mpk)  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tbz2 unpack failed."  
  ;;  
  tgz)  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tgz unpack failed."  
  ;;  
  rar)  
  unrar x ${SOURCEDIR}/${PNAME}/${SRCFILE} ${DEST}  || die ".rar unpack failed."  
  ;;  
  zip|xpi)  
  unzip ${SOURCEDIR}/${PNAME}/${SRCFILE} -d ${DEST} || die ".zip unpack failed."  
  ;;  
  rpm)  
  pushd ${DEST} > /dev/null  
  rpm2targz ${SOURCEDIR}/${PNAME}/${SRCFILE} || die "rpm2targz: .rpm unpack failed."  
  tar --no-same-owner -xvzf ${SRCFILE/.rpm/.tar.gz} || die "tar: .rpm unpack failed."  
  if [[ -f ${DEST}/${SRCFILE/.rpm/.tar.gz} ]]  
  then  
  rm ${DEST}/${SRCFILE/.rpm/.tar.gz}  
  fi  
  ;;  
  *)  
  die "munpack failed"  
  ;;  
  esac  
 }  
   
 mpatch()  
 {  
  local PATCHOPTS  
  local PATCHFILE  
  local i  
   
  PATCHOPTS=$1  
  PATCHFILE=$2  
   
  if [[ -z $2 ]]  
  then  
  PATCHFILE=$1  
   
  ## patch level auto-detection, get patch level  
  for ((i=0; i < 10; i++))  
  do  
  patch --dry-run -Np${i} -i ${SOURCEDIR}/${PNAME}/${PATCHFILE} > /dev/null  
  if [[ $? = 0 ]]  
  then  
  PATCHOPTS="-Np${i}"  
  break  
  fi  
  done  
  fi  
   
  echo -e "${COLBLUE}*** ${COLGREEN}Applying patch '${PATCHFILE}'${COLDEFAULT}"  
  patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}  
 }  
   
 mlibtoolize()  
 {  
  local opts="$@"  
  [[ -z ${opts} ]] && opts="--copy --force"  
   
  libtoolize ${opts} || die "running: mlibtoolize ${opts}"  
 }  
   
 minstalldocs()  
 {  
  local docfiles  
  docfiles="$@"  
   
  if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]  
  then  
  install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."  
  fi  
   
  local i  
  for i in ${docfiles}  
  do  
  if [ -f ${i} ]  
  then  
  cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."  
  install -m 0644 ${SRCDIR}/${i}.gz \  
  ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."  
  fi  
  done  
 }  
   
 mstriplibs()  
 {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 mstripbins()  
 {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 mcompressdocs()  
 {  
  local bindir="$@"  
   
  if [ -d ${bindir}/usr/share/man ]  
  then  
  echo -e "${COLBLUE}===${COLGREEN} compressing man-pages ...${COLDEFAULT}"  
  ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/man  
  fi  
   
  if [ -d ${bindir}/usr/share/info ]  
  then  
  echo -e "${COLBLUE}===${COLGREEN} compressing info-pages ...${COLDEFAULT}"  
  ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/info  
  fi  
 }  
   
 sminclude()  
 {  
  local i  
   
  if [[ -n "$@" ]]  
  then  
  for i in $@  
  do  
  echo "--- Including ${SMAGESCRIPTSDIR}/include/${i}.sminc"  
  source ${SMAGESCRIPTSDIR}/include/${i}.sminc  
  done  
  echo  
  fi  
 }  
   
 setup_distcc_environment()  
 {  
  if [ -x /usr/bin/distcc ]  
  then  
  echo -e "${COLBLUE}---${COLGREEN} Using DistCC for compilation ...${COLDEFAULT}"  
  export PATH=/usr/$(mlibdir)/distcc/bin:${PATH} || die "distcc: could not export new $PATH"  
   
  export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"  
   
  # creating distcc tempdir  
  install -o distcc -g daemon -d ${DISTCC_DIR}  
  chmod 1777 ${DISTCC_DIR}  
  fi  
 }  
   
 setup_ccache_environment()  
 {  
  if [ -x /usr/bin/ccache ]  
  then  
  echo -e "${COLBLUE}---${COLGREEN} Using CCache for compilation ...${COLDEFAULT}"  
  export PATH=/usr/$(mlibdir)/ccache/bin:${PATH} || die "ccache: could not export new $PATH"  
  fi  
 }  
   
   
 # fixes given dependencies to match a MAGE_TARGET  
 # fix_mage_deps -target s/depend # <-- note -target !  
 fix_mage_deps()  
 {  
  local target="$1"  
  local depend="$2"  
  local NDEPEND  
  local sym dep cat pver pname  
   
  # deps and provides are special  
  # they must be fixed to match the target  
   
  # run this only if target and depend is not empty  
  if [ -n "${target}" ] && [ -n "${depend}" ]  
  then  
  # fix DEPEND  
  while read sym dep  
  do  
  # ignore empty lines  
  [[ -z ${dep} ]] && continue  
   
  cat="$(dirname ${dep})"  
  # change if not virtual  
  if [[ ${cat} = virtual ]]  
  then  
  pname="$(basename ${dep})"  
  else  
  # fix pver to target-pver  
  # to get pname-target-pver  
   
  # doing it backwards !  
  pver="${dep##*-}"  
  # full pver  
  pname="$(basename ${dep/-${pver}/})${target}-${pver}"  
  fi  
   
  # do not add empty lines  
  if [ -z "${NDEPEND}" ]  
  then  
  NDEPEND="${sym} ${cat}/${pname}"  
  else  
  NDEPEND="${NDEPEND}  
  ${sym} ${cat}/${pname}"  
  fi  
   
  unset cat pname pver  
  done << EOF  
 ${depend}  
 EOF  
  # set NDEPEND to DEPEND  
  depend="${NDEPEND}"  
  fi  
   
  echo "${depend}"  
 }  
   
 # build_mage_script(): helper functions for regen_mage_tree()  
 # generates an mage file with given information in smage file  
 # needs at least:  
 #   PNAME                 name of pkg  
 #   PVER                  version  
 #   PBUILD                revision  
 #   PCATEGORIE            categorie of the pkg  
 #   STATE                 state of pkg stable|unstable|old  
 #   DESCRIPTION           va short description (opt)  
 #   HOMEPAGE              homepage (opt)  
 #   DEPEND                runtime dependencies (opt)  
 #   SDEPEND               add. needed deps to build the pkg (opt)  
 #   PROVIDE               provides a virtual (opt)  
 #  
 # special tags:  
 #   PKGTYPE               type of pkg  
 #   INHERITS              which functions get included  
 #   SPECIAL_FUNCTIONS     special functions which should also be added  
 #                         warning: they get killed before the build starts !  
 #   SPLIT_PACKAGES        names of all subpackages which are splitted from parent  
 #   SPLIT_PACKAGE_BASE    base package name for splitpackages  
 #                         (only in the resulting magefile}  
 #  
 #   MAGE_TREE_DEST        target destination of the generated tree  
 #   REGEN_MAGE_TREE       set to 'true' to enable this  
 #  
 # gets called with build_mage_script target  
 build_mage_script()  
 {  
  local magefile  
  local dest  
  local target  
  local split_pkg_base  
  local sym  
  local depname  
   
  # if MAGE_TREE_DEST not set use BUILDDIR  
  : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}  
   
  # determinate which suffix this mage file should get, if any  
  [[ $1 = --target ]] && shift && target="-$1"  
   
  # mark package as splitpackage  
  [[ $1 = --split-pkg-base ]] && shift && split_pkg_base="$1"  
   
  # name of magefile  
  magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"  
   
  # destination to magefile  
  dest="${MAGE_TREE_DEST}/${PCATEGORIE}/${PNAME}${target}/${magefile}"  
   
  # show what we are doing  
  echo -e "${COLBLUE}===${COLGREEN} generating mage file:${COLDEFAULT}"  
  echo "${dest}"  
   
  install -d "$(dirname ${dest})"  
  # now build the mage file  
  > ${dest}  
   
  # header  
  echo '# $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.62 2007-11-28 10:47:50 niro Exp $' >> ${dest}  
  echo  >> ${dest}  
   
  # pgkname and state  
  echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}  
  echo "STATE=\"${STATE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # description and homepage  
  echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}  
  echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # special tags and vars  
  echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}  
   
  # echo MAGE_TARGETS ## note -target is needed !  
  echo "MAGE_TARGETS=\"${target}\"" >> ${dest}  
  echo >> ${dest}  
   
  # split package base  
  echo "SPLIT_PACKAGE_BASE=\"${split_pkg_base}\"" >> ${dest}  
  echo >> ${dest}  
   
  # add special vars  
  if [ -n "${SPECIAL_VARS}" ]  
  then  
  local i  
  for i in ${SPECIAL_VARS}  
  do  
  # being tricky here :)  
  echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}  
  done  
  echo  >> ${dest}  
  fi  
   
  # add at least all includes  
  if [ -n "${INHERITS}" ]  
  then  
  echo -n "minclude"  >> ${dest}  
  local i  
  for i in ${INHERITS}  
  do  
  echo -n " ${i}"  >> ${dest}  
  done  
  echo  >> ${dest}  
  fi  
  echo >> ${dest}  
   
  # deps and provides  
  echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}  
  echo >> ${dest}  
  echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}  
  echo >> ${dest}  
  echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # add special functions  
  if [ -n "${SPECIAL_FUNCTIONS}" ]  
  then  
  local i  
  for i in ${SPECIAL_FUNCTIONS}  
  do  
  # add to mage (quotes needed !)  
  typeset -f "${i}" >> ${dest}  
  echo >> ${dest}  
  # unset to be safe (quotes needed !)  
  #unset "${i}" <-- later to get every target built  
  done  
  echo  >> ${dest}  
  fi  
   
  # pre|post-install|removes  
  typeset -f preinstall >> ${dest}  
  echo  >> ${dest}  
  typeset -f postinstall >> ${dest}  
  echo  >> ${dest}  
  typeset -f preremove >> ${dest}  
  echo  >> ${dest}  
  typeset -f postremove >> ${dest}  
  echo  >> ${dest}  
 }  
   
 regen_mage_tree()  
 {  
  local i  
   
  # build them only if requested  
  if [[ ${REGEN_MAGE_TREE} = true ]]  
  then  
  # run it without targets  
  if [[ -n ${MAGE_TARGETS} ]]  
  then  
  # build for each target a mage file  
  # run it with several targets  
  echo  
  for i in ${MAGE_TARGETS}  
  do  
  build_mage_script --target "${i}"  
  done  
  echo  
   
  # run it for splitpackages  
  elif [[ -n ${SPLIT_PACKAGES} ]]  
  then  
  local split_pkg_base="${PNAME}"  
  # save smage environment  
  split_save_variables  
  # build for each subpackage a mage file  
  # run it with several targets  
  echo  
  for i in ${SPLIT_PACKAGES}  
  do  
  # get the right variables for the split  
  export PNAME="${i}"  
  split_info_${i}  
  build_mage_script --split-pkg-base "${split_pkg_base}"  
  # restore smage environment  
  split_restore_variables  
  done  
  echo  
  # unset all saved smage variables  
  split_unset_variables  
   
  else  
  echo  
  build_mage_script  
  echo  
  fi  
  fi  
   
  # now unset all uneeded vars to be safe  
  # unset PKGNAME <-- don't do that; smage needs this var  
  # unset to be safe (quotes needed !)  
 # for i in ${SPECIAL_FUNCTIONS}  
 # do  
 # unset "${i}"  
 # done  
  unset SPECIAL_FUNCTIONS  
 # for i in ${SPECIAL_VARS}  
 # do  
 # unset "${i}"  
 # done  
  unset SPECIAL_VARS  
  unset STATE  
  unset DESCRIPTION  
  unset HOMEPAGE  
  unset PKGTYPE  
  unset INHERITS  
  unset DEPEND  
  unset SDEPEND  
  unset PROVIDE  
  unset preinstall  
  unset postinstall  
  unset preremove  
  unset postremove  
 }  
   
 split_save_variables()  
 {  
  export SAVED_PNAME="${PNAME}"  
  export SAVED_PVER="${PVER}"  
  export SAVED_PBUILD="${PBUILD}"  
  export SAVED_PCATEGORIE="${PCATEGORIE}"  
  export SAVED_DESCRIPTION="${DESCRIPTION}"  
  export SAVED_HOMEPAGE="${HOMEPAGE}"  
  export SAVED_SPECIAL_VARS="${SPECIAL_VARS}"  
  export SAVED_STATE="${STATE}"  
  export SAVED_PKGTYPE="${PKGTYPE}"  
  export SAVED_INHERITS="${INHERITS}"  
  export SAVED_DEPEND="${DEPEND}"  
  export SAVED_SDEPEND="${SDEPEND}"  
  export SAVED_PROVIDE="${PROVIDE}"  
  export SAVED_NOPKGBUILD="${NOPKGBUILD}"  
   
  # bindir too  
  export SAVED_BINDIR="${BINDIR}"  
   
  # export the SPLIT_PACKAGE_BASE  
  export SPLIT_PACKAGE_BASE="${SAVED_PNAME}"  
   
  # functions  
  if [[ ! -z $(typeset -f preinstall) ]]  
  then  
  # rename the old one  
  local saved_preinstall  
  saved_preinstall=SAVED_$(typeset -f preinstall)  
  eval "${saved_preinstall}"  
  export -f SAVED_preinstall  
  fi  
   
  if [[ ! -z $(typeset -f postinstall) ]]  
  then  
  # rename the old one  
  local saved_postinstall  
  saved_postinstall=SAVED_$(typeset -f postinstall)  
  eval "${saved_postinstall}"  
  export -f SAVED_postinstall  
  fi  
   
  if [[ ! -z $(typeset -f preremove) ]]  
  then  
  # rename the old one  
  local saved_preremove  
  saved_preremove=SAVED_$(typeset -f preremove)  
  eval "${saved_preremove}"  
  export -f SAVED_preremove  
  fi  
   
  if [[ ! -z $(typeset -f postremove) ]]  
  then  
  # rename the old one  
  local saved_postremove  
  saved_postremove=SAVED_$(typeset -f postremove)  
  eval "${saved_postremove}"  
  export -f SAVED_postremove  
  fi  
 }  
   
 split_restore_variables()  
 {  
  export PNAME="${SAVED_PNAME}"  
  export PVER="${SAVED_PVER}"  
  export PBUILD="${SAVED_PBUILD}"  
  export PCATEGORIE="${SAVED_PCATEGORIE}"  
  export DESCRIPTION="${SAVED_DESCRIPTION}"  
  export HOMEPAGE="${SAVED_HOMEPAGE}"  
  export SPECIAL_VARS="${SAVED_SPECIAL_VARS}"  
  export STATE="${SAVED_STATE}"  
  export PKGTYPE="${SAVED_PKGTYPE}"  
  export INHERITS="${SAVED_INHERITS}"  
  export DEPEND="${SAVED_DEPEND}"  
  export SDEPEND="${SAVED_SDEPEND}"  
  export PROVIDE="${SAVED_PROVIDE}"  
  export NOPKGBUILD="${SAVED_NOPKGBUILD}"  
   
  # bindir too  
  export BINDIR="${SAVED_BINDIR}"  
   
  # functions  
  if [[ ! -z $(typeset -f SAVED_preinstall) ]]  
  then  
  # rename the old one  
  local saved_preinstall  
  saved_preinstall=$(typeset -f SAVED_preinstall)  
  eval "${saved_preinstall/SAVED_/}"  
  export -f preinstall  
  fi  
   
  if [[ ! -z $(typeset -f SAVED_postinstall) ]]  
  then  
  # rename the old one  
  local saved_postinstall  
  saved_postinstall=$(typeset -f SAVED_postinstall)  
  eval "${saved_postinstall/SAVED_/}"  
  export -f postinstall  
  fi  
   
  if [[ ! -z $(typeset -f SAVED_preremove) ]]  
  then  
  # rename the old one  
  local saved_preremove  
  saved_preremove=$(typeset -f SAVED_preremove)  
  eval "${saved_preremove/SAVED_/}"  
  export -f preremove  
  fi  
   
  if [[ ! -z $(typeset -f SAVED_postremove) ]]  
  then  
  # rename the old one  
  local saved_postremove  
  saved_postremove=$(typeset -f SAVED_postremove)  
  eval "${saved_postremove/SAVED_/}"  
  export -f postremove  
  fi  
 }  
   
 split_unset_variables()  
 {  
  # unset saved vars; not needed anymore  
  unset SAVED_PNAME  
  unset SAVED_PVER  
  unset SAVED_PBUILD  
  unset SAVED_PCATEGORIE  
  unset SAVED_DESCRIPTION  
  unset SAVED_HOMEPAGE  
  unset SAVED_SPECIAL_VARS  
  unset SAVED_STATE  
  unset SAVED_PKGTYPE  
  unset SAVED_INHERITS  
  unset SAVED_DEPEND  
  unset SAVED_SDEPEND  
  unset SAVED_PROVIDE  
  unset SAVED_BINDIR  
  unset SAVED_NOPKGBUILD  
  unset SPLIT_PACKAGE_BASE  
  unset -f SAVED_preinstall  
  unset -f SAVED_postinstall  
  unset -f SAVED_preremove  
  unset -f SAVED_postremove  
 }  
   
 export_inherits()  
 {  
  local include="$1"  
  shift  
   
  while [ "$1" ]  
  do  
  local functions="$1"  
   
  # sanity checks  
  [ -z "${include}" ] && die "export_inherits(): \$include not given."  
  [ -z "${functions}" ] && die "export_inherits(): \$functions not given."  
   
  eval "${functions}() { ${include}_${functions} ; }"  
   
  # debug  
  [[ ${MAGEDEBUG} = on ]] && typeset -f "${functions}"  
   
  shift  
  done  
 }  
   
 generate_package_md5sum()  
 {  
  local dest  
  local pcat  
  local pname  
  local pver  
  local pbuild  
  local parch  
  local target  
  local pkgname  
   
  # very basic getops  
  for i in $*  
  do  
  case $1 in  
  --pcat|-c) shift; pcat="$1" ;;  
  --pname|-n) shift; pname="$1" ;;  
  --pver|-v) shift; pver="$1" ;;  
  --pbuild|-b) shift; pbuild="$1" ;;  
  --parch|a) shift; parch="$1" ;;  
  --target|t) shift; target="$1" ;;  
  esac  
  shift  
  done  
   
  # sanity checks; abort if not given  
  [ -z "${pcat}" ] && die "generate_package_md5sum() \$pcat not given."  
  [ -z "${pname}" ] && die "generate_package_md5sum() \$pname not given."  
  [ -z "${pver}" ] && die "generate_package_md5sum() \$pver not given."  
  [ -z "${pbuild}" ] && die "generate_package_md5sum() \$pbuild not given."  
  [ -z "${parch}" ] && die "generate_package_md5sum() \$parch not given."  
   
  # check needed global vars  
  [ -z "${PKGDIR}" ] && die "generate_package_md5sum() \$PKGDIR not set."  
  [ -z "${PKGSUFFIX}" ] && die "generate_package_md5sum() \$PKGSUFFIX not set."  
   
  # fix target as it may be empty !  
  [ -n "${target}" ] && target="-${target}"  
   
   
  # build pkgname  
  pkgname="${pname}${target}-${pver}-${parch}-${pbuild}"  
   
  # build pkg-md5-sum only if requested  
  if [[ ${REGEN_MAGE_TREE} = true ]]  
  then  
  echo -ne "${COLBLUE}===${COLGREEN} generating md5's for ${pkgname}.${PKGSUFFIX} ... ${COLDEFAULT}"  
   
  # abort if not exist  
  if [ ! -f ${PKGDIR}/${pkgname}.${PKGSUFFIX} ]  
  then  
  echo -e "${COLRED}! exists${COLDEFAULT}"  
  return 0  
  fi  
   
  # if MAGE_TREE_DEST not set use BUILDDIR  
  : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}  
   
  # setup md5 dir  
  dest="${MAGE_TREE_DEST}/${pcat}/${pname}${target}/md5"  
  install -d ${dest}  
   
  # gen md5sum  
  ( cd ${PKGDIR}; md5sum "${pkgname}.${PKGSUFFIX}" ) \  
  > ${dest}/${pkgname}.md5  
  echo -e "${COLGREEN}done${COLDEFAULT}"  
  fi  
 }  
   
 source_pkg_build()  
 {  
  if [[ ${PKGTYPE} = virtual ]]  
  then  
  echo "Virtual package detected; src-pkg-tarball not necessary ..."  
  return 0  
  fi  
   
  if [[ ! -d ${SOURCEDIR}/${PNAME} ]]  
  then  
  echo "No SRC_URI defined; src-pkg-tarball not necessary ..."  
  return 0  
  fi  
   
  [ -z "${SRCPKGDIR}" ] && die "\$SRCPKGDIR not found. Please setup your ${MAGERC} correctly."  
   
  echo -e "${COLGREEN}Creating source package tarball ... ${COLDEFAULT}"  
   
  # include the smage2 file  
  cp ${SMAGENAME} ${SOURCEDIR}/${PNAME}  
   
  ( cd ${SOURCEDIR}; tar cvjf ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${PNAME}; )  
  [[ ! -d ${SRCPKGDIR} ]] && install -d ${SRCPKGDIR}  
  mv ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${SRCPKGDIR}/${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX}  
   
  echo -e "${COLGREEN}Source package ${COLBLUE}${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX} ${COLGREEN}successfully builded.${COLDEFAULT}"  
 }  
   
 step_by_step()  
 {  
  if [[ ${STEP_BY_STEP} = true ]]  
  then  
  echo -e "${COLRED}Step-by-step enabled! Paused after $1.${COLDEFAULT}"  
  echo "Press [enter] to continue"  
  read  
  fi  
 }  
   
   
33  # print out our version  # print out our version
34  showversion  showversion
35  echo  echo
36    
37  if [ -z "$1" ]  if [[ -z ${SMAGENAME} ]]
38  then  then
39   echo "No .smage2 file given. Exiting."   echo "No .smage2 file given. Exiting."
40   echo   echo
41   exit 1   exit 1
42  fi  fi
43    
44    # load supported mage features
45    load_mage_features
46    
47  # updating smage2-scripts  # updating smage2-scripts
48  if [[ $1 = update ]]  if [[ $1 = update ]]
49  then  then
# Line 1188  fi Line 58  fi
58  # creates md5sums for smages to given dir  # creates md5sums for smages to given dir
59  if [[ $1 = calcmd5 ]]  if [[ $1 = calcmd5 ]]
60  then  then
61   if [ $# -ge 3 ]   if [ $# -ge 2 ]
62   then   then
63   SMAGENAME="$2"   SMAGENAME="$2"
64   MD5DIR="$3"   MD5DIR="$3"
65   source ${SMAGENAME} || die "download source failed"   [[ -z ${MD5DIR} ]] && MD5DIR="$(dirname ${SMAGENAME})/md5"
66    
67     smagesource ${SMAGENAME} || die "download source failed"
68    
69   # overridable sourcedir; must be declared after source of the smage2   # overridable sourcedir; must be declared after source of the smage2
70   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
# Line 1244  then Line 116  then
116   echo   echo
117   else   else
118   echo "Usage: Calculating MD5 Sums:"   echo "Usage: Calculating MD5 Sums:"
119   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME /path/to/MD5DIR"   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME [/path/to/MD5DIR]"
120   echo   echo
121   echo   echo
122   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
# Line 1266  then Line 138  then
138   # get smage   # get smage
139   SMAGENAME="$2"   SMAGENAME="$2"
140   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
141   source ${SMAGENAME} || die "download source failed"   smagesource ${SMAGENAME} || die "download source failed"
142    
143   download_sources   download_sources
144   exit 0   exit 0
# Line 1278  then Line 150  then
150   # set correct SMAGENAME   # set correct SMAGENAME
151   SMAGENAME="$2"   SMAGENAME="$2"
152   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
153   source ${SMAGENAME} || die "regen: smage2 not found"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
154    
155   regen_mage_tree   regen_mage_tree
156    
# Line 1289  then Line 161  then
161   do   do
162   # build md5sum for existing packages   # build md5sum for existing packages
163   generate_package_md5sum \   generate_package_md5sum \
164   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
165   --pname "${PNAME}" \   --pname "${PNAME}" \
166   --pver "${PVER}" \   --pver "${PVER}" \
167   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
# Line 1306  then Line 178  then
178   # get the right variables for the split   # get the right variables for the split
179   export PNAME="${subpackage}"   export PNAME="${subpackage}"
180   split_info_${subpackage}   split_info_${subpackage}
181     # fix PCATEGORIE -> PCAT
182     if [[ ! -z ${PCATEGORIE} ]]
183     then
184     PCAT="${PCATEGORIE}"
185     unset PCATEGORIE
186     fi
187   # build md5sum for existing packages   # build md5sum for existing packages
188   generate_package_md5sum \   generate_package_md5sum \
189   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
190   --pname "${PNAME}" \   --pname "${PNAME}" \
191   --pver "${PVER}" \   --pver "${PVER}" \
192   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
# Line 1322  then Line 200  then
200   else   else
201   # build md5sum for existing packages   # build md5sum for existing packages
202   generate_package_md5sum \   generate_package_md5sum \
203   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
204   --pname "${PNAME}" \   --pname "${PNAME}" \
205   --pver "${PVER}" \   --pver "${PVER}" \
206   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
# Line 1340  then Line 218  then
218    
219   echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"   echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
220    
221   source ${SMAGENAME} || die "regen: smage2 not found"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
222    
223   if [[ -d ${SOURCEDIR}/${PNAME} ]]   if [[ -d ${SOURCEDIR}/${PNAME} ]]
224   then   then
# Line 1356  fi Line 234  fi
234  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
235  then  then
236   SRCPKGTARBALL="${2}"   SRCPKGTARBALL="${2}"
237   USE_SRC_PKG_TARBALL=true   msetfeature "srcpkgtarball"
238    
239   # abort if given file is not a source pkg   # abort if given file is not a source pkg
240   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
# Line 1377  then Line 255  then
255   [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"   [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"
256  fi  fi
257    
258    if [ "$1" == "--resume" -a -n "$2" ]
259    then
260     msetfeature "resume"
261     SMAGENAME="$2"
262    fi
263    
264  [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."  [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."
265  [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&  [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&
# Line 1389  fi Line 272  fi
272  [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"  [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
273  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
274    
275  source ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
276  PKGNAME="${PNAME}-${PVER}-${ARCH}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}"
277  MD5DIR="$(dirname ${SMAGENAME})/md5"  MD5DIR="$(dirname ${SMAGENAME})/md5"
278  SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"  SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"
279    
# Line 1400  echo -e "${COLGREEN}Compiling ${PKGNAME} Line 283  echo -e "${COLGREEN}Compiling ${PKGNAME}
283  # auto regen mage tree if requested  # auto regen mage tree if requested
284  regen_mage_tree  regen_mage_tree
285    
286  if [[ ${CREATE_SRC_PKG_TARBALL} = true ]]  if mqueryfeature "srcpkgbuild"
287  then  then
288   if [[ -d ${SOURCEDIR}/${PNAME} ]]   if [[ -d ${SOURCEDIR}/${PNAME} ]]
289   then   then
# Line 1410  then Line 293  then
293  fi  fi
294    
295  # download sources  # download sources
296  [[ ${USE_SRC_PKG_TARBALL} != true ]] && download_sources  mqueryfeature "srcpkgtarball" || download_sources
297    
298  # fixes some issues with these functions  # fixes some issues with these functions
299  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
300  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
301    export -f src_check || die "src_check export failed"
302  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
303    
304  # fixes some compile issues  # fixes some compile issues
305  export CHOST="${CHOST}" || die "CHOST export failed"  export CHOST="${CHOST}" || die "CHOST export failed"
306  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"
307  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"  if [[ -z ${CXXFLAGS} ]]
308    then
309     export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"
310    else
311     export CXXFLAGS="${CXXFLAGS}" || die "CXXFLAGS export failed"
312    fi
313    export LDFLAGS="${LDFLAGS}" || die "LDFLAGS export failed"
314  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
315  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
316    
   
317  # setup distcc  # setup distcc
318  # setup for distcc goes *before* ccache, so ccache comes before distcc in path  # setup for distcc goes *before* ccache, so ccache comes before distcc in path
319  [[ ${SMAGE_USE_DISTCC} = true ]] && setup_distcc_environment  mqueryfeature "distcc" && setup_distcc_environment
320    
321  # setup ccache  # setup ccache
322  [[ ${SMAGE_USE_CCACHE} = true ]] && setup_ccache_environment  mqueryfeature "ccache" && setup_ccache_environment
   
 # small sleep to show our settings  
 sleep 1  
323    
324  # cleans up build if a previously one exists  if mqueryfeature "resume"
 if [ -d ${BUILDDIR} ]  
325  then  then
326   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   echo -e "${COLMAGENTA}Resume requested; continuing previous build${COLDEFAULT}"
 fi  
 install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  
327    
328  # cleans up srcdir if a previously unpacked one exists   # setup build logging
329  if [ -d ${SRCDIR} ]   [[ ! -d /var/log/smage ]] && install -d /var/log/smage
330  then   if [[ -f /var/log/smage/${PKGNAME}.log.bz2 ]]
331   rm -rf ${SRCDIR}   then
332  fi   bunzip2 -f /var/log/smage/${PKGNAME}.log.bz2
333     fi
334     echo -e "### Resume started on $(date) ###\n" >> /var/log/smage/${PKGNAME}.log
335    
336  # cleans up bindir if a previous build exists or creates a new one  else
337  if [ -d ${BINDIR} ]   # clean up builddir if a previously one exist
338  then   if [ -d ${BUILDDIR} ]
339   rm -rf ${BINDIR}   then
340  fi   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
341  install -d ${BINDIR} || die "couldn't create \$BINDIR."   fi
342     install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
343    
344  # cleans up package temp dir if a previous build exists   # clean up srcdir if a previously unpacked one exist
345  if [ -d ${BUILDDIR}/${PKGNAME} ]   if [ -d ${SRCDIR} ]
346  then   then
347   rm -rf ${BUILDDIR}/${PKGNAME}   rm -rf ${SRCDIR}
348     fi
349    
350     # clean up bindir if a previous build exist or create a new one
351     if [ -d ${BINDIR} ]
352     then
353     rm -rf ${BINDIR}
354     fi
355     install -d ${BINDIR} || die "couldn't create \$BINDIR."
356    
357     # clean up package temp dir if a previous build exist
358     if [ -d ${BUILDDIR}/${PKGNAME} ]
359     then
360     rm -rf ${BUILDDIR}/${PKGNAME}
361     fi
362    
363     # clean up stamps dir
364     if [ -d ${BUILDDIR}/.stamps ]
365     then
366     rm -rf ${BUILDDIR}/.stamps
367     fi
368    
369     # setup build logging
370     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
371     echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
372  fi  fi
373    
374  # cleans up timestamp if one exists  if [[ ${PKGTYPE} = virtual ]]
 if [ -f /var/tmp/timestamp ]  
375  then  then
376   mage rmstamp   echo "virtual package detected; nothing will be build ..."
377  fi   # automatically set !pkgbuild here too
378     msetfeature "!pkgbuild"
379    else
380     ( run_resume src_prepare || src_prepare ) | ${SMAGE_LOG_CMD}
381     die_pipestatus 0 "src_prepare failed"
382     resume_stamp src_prepare
383     step_by_step src_prepare
384    
385     ( run_resume src_compile || src_compile ) | ${SMAGE_LOG_CMD}
386     die_pipestatus 0 "src_compile failed"
387     resume_stamp src_compile
388     step_by_step src_compile
389    
390  # setup build loggins   # only run checks if requested
391  [[ ! -d /var/log/smage ]] && install -d /var/log/smage   if mqueryfeature "!check"
392  echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log   then
393     echo "!check detected; src_check() will not be run!" | ${SMAGE_LOG_CMD}
394  src_prepare | ${SMAGE_LOG_CMD}   else
395  die_pipestatus 0 "src_prepare failed"   ( run_resume src_check || src_check ) | ${SMAGE_LOG_CMD}
396  step_by_step $_   die_pipestatus 0 "src_check failed"
397     resume_stamp src_check
398  src_compile | ${SMAGE_LOG_CMD}   fi
399  die_pipestatus 0 "src_compile failed"   step_by_step src_check
 step_by_step $_  
   
 # build several subpackages  
 if [[ -n ${SPLIT_PACKAGES} ]]  
 then  
  # save bindir & pname  
  split_save_variables  
  export SAVED_BINDIR="${BINDIR}"  
  for subpackage in ${SPLIT_PACKAGES}  
  do  
  if typeset -f src_install_${subpackage} > /dev/null  
  then  
  # export subpackage bindir  
  export BINDIR="${SAVED_BINDIR}_${subpackage}"  
  # export PNAME, several internal function and include  
  # rely on this variable  
  export PNAME="${subpackage}"  
400    
401   echo   # build several subpackages
402   echo -en "${COLBLUE}*** ${COLDEFAULT}"   if [[ -n ${SPLIT_PACKAGES} ]]
403   echo -en "  Running ${COLGREEN}split src_install()${COLDEFAULT}"   then
404   echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"   # save bindir & pname
405   echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."   split_save_variables
406     export SAVED_BINDIR="${BINDIR}"
407   src_install_${subpackage} | ${SMAGE_LOG_CMD}   for subpackage in ${SPLIT_PACKAGES}
408   die_pipestatus 0 "src_install_${subpackage} failed"   do
409   step_by_step $_   if typeset -f src_install_${subpackage} > /dev/null
410   fi   then
411   done   # export subpackage bindir
412   # restore bindir & pname   export BINDIR="${SAVED_BINDIR}_${subpackage}"
413   split_restore_variables   # export PNAME, several internal function and include
414   # unset all saved smage variables   # rely on this variable
415   split_unset_variables   export PNAME="${subpackage}"
416  else  
417   src_install | ${SMAGE_LOG_CMD}   echo
418   die_pipestatus 0 "src_install failed"   echo -en "${COLBLUE}*** ${COLDEFAULT}"
419   step_by_step $_   echo -en "  Running ${COLGREEN}split src_install()${COLDEFAULT}"
420     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
421     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
422    
423     ( run_resume src_install_${subpackage} || src_install_${subpackage} ) | ${SMAGE_LOG_CMD}
424     die_pipestatus 0 "src_install_${subpackage} failed"
425     resume_stamp src_install_${subpackage}
426     step_by_step src_install_${subpackage}
427     fi
428     done
429     # restore bindir & pname
430     split_restore_variables
431     # unset all saved smage variables
432     split_unset_variables
433     else
434     ( run_resume src_install || src_install ) | ${SMAGE_LOG_CMD}
435     die_pipestatus 0 "src_install failed"
436     resume_stamp src_install
437     step_by_step src_install
438     fi
439  fi  fi
440    
441  # compressing doc, info & man files  # echo for sake of good-looking
442  if [[ -n ${SPLIT_PACKAGES} ]]  echo
443    
444    if mqueryfeature "!compressdoc"
445    then
446     echo -e "!compressdoc detected; documentation will not be compressed ..."
447    elif mqueryfeature "!pkgbuild"
448  then  then
449   for subpackage in ${SPLIT_PACKAGES}   echo "!pkgbuild detected; skipping documentation compression..."
  do  
  mcompressdocs ${BINDIR}_${subpackage}  
  done  
450  else  else
451   mcompressdocs ${BINDIR}   # compressing doc, info & man files
452     if [[ -n ${SPLIT_PACKAGES} ]]
453     then
454     for subpackage in ${SPLIT_PACKAGES}
455     do
456     run_resume post-mcompressdoc_${subpackage} || mcompressdocs ${BINDIR}_${subpackage}
457     resume_stamp post-mcompressdoc_${subpackage}
458     done
459     else
460     run_resume post-mcompressdoc || mcompressdocs ${BINDIR}
461     resume_stamp post-mcompressdoc
462     fi
463  fi  fi
464    
465    if mqueryfeature "!libtool"
466    then
467     if mqueryfeature "!pkgbuild"
468     then
469     echo "!pkgbuild detected; skipping libtool archive stripping ..."
470     else
471     if [[ -n ${SPLIT_PACKAGES} ]]
472     then
473     for subpackage in ${SPLIT_PACKAGES}
474     do
475     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
476     run_resume post-mstriplibtoolarchive_${subpackage} || mstriplibtoolarchive ${BINDIR}_${subpackage}
477     resume_stamp post-mstriplibtoolarchive_${subpackage}
478     done
479     else
480     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
481     run_resume post-mstriplibtoolarchive || mstriplibtoolarchive ${BINDIR}
482     resume_stamp post-mstriplibtoolarchive
483     fi
484     fi
485    fi
486    
487  # stripping all bins and libs  if mqueryfeature "purge"
488  case ${NOSTRIP} in  then
489   true|TRUE|yes|y)   if mqueryfeature "!pkgbuild"
490   echo -e "NOSTRIP=true detected; Package will not be stripped ..."   then
491   ;;   echo "!pkgbuild detected; skipping file purgation..."
492   *)   else
493   if [[ -n ${SPLIT_PACKAGES} ]]   if [[ -n ${SPLIT_PACKAGES} ]]
494   then   then
495   for subpackage in ${SPLIT_PACKAGES}   for subpackage in ${SPLIT_PACKAGES}
496   do   do
497   echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"   echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
498   mstripbins ${BINDIR}_${subpackage}   run_resume post-mpurgetargets_${subpackage} || mpurgetargets ${BINDIR}_${subpackage}
499   echo -e "${COLBLUE}===${COLGREEN} stripping libraries for '${subpackage}' ...${COLDEFAULT}"   resume_stamp post-mpurgetargets_${subpackage}
  mstriplibs ${BINDIR}_${subpackage}  
500   done   done
501   else   else
502   echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"   echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
503   mstripbins ${BINDIR}   run_resume post-mpurgetargets || mpurgetargets ${BINDIR}
504   echo -e "${COLBLUE}===${COLGREEN} stripping libraries ...${COLDEFAULT}"   resume_stamp post-mpurgetargets
  mstriplibs ${BINDIR}  
505   fi   fi
506   ;;   fi
507  esac  fi
508    
509  # the new buildpkg command  # stripping all bins and libs
510  case ${NOPKGBUILD} in  if mqueryfeature "!strip"
511   true|TRUE|yes|y)  then
512   echo -e "NOPGKBUILD=true detected; Package will not be build ..."   echo -e "!strip detected; Package will not be stripped ..."
513   ;;  elif mqueryfeature "!pkgbuild"
514   *)  then
515     echo "!pkgbuild detected; skipping stripping of the package ..."
516    else
517     if [[ -n ${SPLIT_PACKAGES} ]]
518     then
519     for subpackage in ${SPLIT_PACKAGES}
520     do
521     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
522     run_resume post-mstripbins_${subpackage} || mstripbins ${BINDIR}_${subpackage}
523     resume_stamp post-mstripbins_${subpackage}
524     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
525     run_resume post-mstriplibs_${subpackage} || mstriplibs ${BINDIR}_${subpackage}
526     resume_stamp post-mstriplibs_${subpackage}
527     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
528     run_resume post-mstripstatic_${subpackage} || mstripstatic ${BINDIR}_${subpackage}
529     resume_stamp post-mstripstatic_${subpackage}
530     done
531     else
532     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
533     run_resume post-mstripbins || mstripbins ${BINDIR}
534     resume_stamp post-mstripbins
535     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
536     run_resume post-mstriplibs || mstriplibs ${BINDIR}
537     resume_stamp post-mstriplibs
538     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
539     run_resume post-mstripstatic || mstripstatic ${BINDIR}
540     resume_stamp post-mstripstatic
541     fi
542    fi
543    
544    if mqueryfeature "!pkgbuild"
545    then
546     echo -e "!pkgbuild detected; Package will not be build ..."
547    else
548   # build several targets   # build several targets
549   if [[ -n ${MAGE_TARGETS} ]]   if [[ -n ${MAGE_TARGETS} ]]
550   then   then
551   for target in ${MAGE_TARGETS}   for target in ${MAGE_TARGETS}
552   do   do
553   # check if an special target_pkgbuild exists   # check if a special target_pkgbuild exists
554   if typeset -f ${target}_pkgbuild > /dev/null   if typeset -f ${target}_pkgbuild > /dev/null
555   then   then
556   # run it   # run it
557   ${target}_pkgbuild   run_resume post-${target}_pkgbuild || ${target}_pkgbuild
558     resume_stamp post-${target}_pkgbuild
559   fi   fi
560   # now create the target package   # now create the target package
561   ${MLIBDIR}/pkgbuild_dir.sh \   run_resume post-pkg_builddir_${target} || ${MLIBDIR}/pkgbuild_dir.sh \
562   "${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD}" \   "${PNAME}-${target}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
563   ${BINDIR} || die "target: ${target} package-build failed"   ${BINDIR} || die "target: ${target} package-build failed"
564     resume_stamp post-pkg_builddir_${target}
565    
566   # build pkg-md5-sum if requested   # build pkg-md5-sum if requested
567   generate_package_md5sum \   run_resume post-md5sum_${target} || generate_package_md5sum \
568   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
569   --pname "${PNAME}" \   --pname "${PNAME}" \
570   --pver "${PVER}" \   --pver "${PVER}" \
571   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
572   --parch "${ARCH}" \   --parch "${ARCH}" \
573   --target "${target}"   --target "${target}"
574     resume_stamp post-md5sum_${target}
575    
576   echo -e "${COLGREEN}\nPackage ${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"   echo -e "${COLGREEN}\nPackage ${PNAME}-${target}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
577   done   done
578    
579   # build several subpackages   # build several subpackages
# Line 1595  case ${NOPKGBUILD} in Line 585  case ${NOPKGBUILD} in
585   # get the right variables for the split   # get the right variables for the split
586   export PNAME="${subpackage}"   export PNAME="${subpackage}"
587   split_info_${PNAME}   split_info_${PNAME}
588     # fix PCATEGORIE -> PCAT
589     if [[ ! -z ${PCATEGORIE} ]]
590     then
591     PCAT="${PCATEGORIE}"
592     unset PCATEGORIE
593     fi
594    
595   # jump to next one if NOPKGBUILD is set in split_info   # jump to next one if !pkgbuild is set in split_info
596   case ${NOPKGBUILD} in   mqueryfeature "!pkgbuild" && continue
  true|TRUE|yes|y) continue ;;  
  esac  
597    
598   # check if an special subpackage_pkgbuild exists   # check if an special subpackage_pkgbuild exists
599   if typeset -f ${PNAME}_pkgbuild > /dev/null   if typeset -f ${PNAME}_pkgbuild > /dev/null
600   then   then
601   # run it   # run it
602   ${PNAME}_pkgbuild   run_resume post-${PNAME}_pkgbuild || ${PNAME}_pkgbuild
603     resume_stamp post-${PNAME}_pkgbuild
604   fi   fi
605   # now create the target package   # now create the target package
606   ${MLIBDIR}/pkgbuild_dir.sh \   run_resume post-pkg_builddir_${PNAME} || ${MLIBDIR}/pkgbuild_dir.sh \
607   "${PNAME}-${PVER}-${ARCH}-${PBUILD}" \   "${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
608   "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"   "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
609     resume_stamp post-pkg_builddir_${PNAME}
610    
611   # build pkg-md5-sum if requested   # build pkg-md5-sum if requested
612   generate_package_md5sum \   run_resume post-md5sum_${PNAME} || generate_package_md5sum \
613   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
614   --pname "${PNAME}" \   --pname "${PNAME}" \
615   --pver "${PVER}" \   --pver "${PVER}" \
616   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
617   --parch "${ARCH}"   --parch "${ARCH}"
618     resume_stamp post-md5sum_${PNAME}
619    
620   echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"   echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
621    
622   # restore smage environment   # restore smage environment
623   split_restore_variables   split_restore_variables
# Line 1629  case ${NOPKGBUILD} in Line 626  case ${NOPKGBUILD} in
626   split_unset_variables   split_unset_variables
627    
628   else   else
629   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"   run_resume post-pkg_builddir || ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"
630     resume_stamp post-pkg_builddir
631    
632   # build pkg-md5-sum if requested   # build pkg-md5-sum if requested
633   generate_package_md5sum \   run_resume post-md5sum || generate_package_md5sum \
634   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
635   --pname "${PNAME}" \   --pname "${PNAME}" \
636   --pver "${PVER}" \   --pver "${PVER}" \
637   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
638   --parch "${ARCH}"   --parch "${ARCH}"
639     resume_stamp post-md5sum
640    
641   echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"   echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"
642   fi   fi
643    
644   # build src-pkg-tarball if requested   # build src-pkg-tarball if requested
645   [[ ${CREATE_SRC_PKG_TARBALL} = true ]] && source_pkg_build ${SMAGENAME}   if mqueryfeature "srcpkgbuild"
646   ;;   then
647  esac   run_resume post-srcpkgbuild || source_pkg_build ${SMAGENAME}
648     resume_stamp post-srcpkgbuild
649     fi
650    fi
651    
652  if [[ ${SMAGE_BUILD_LOGGING} != false ]]  if mqueryfeature "buildlog"
653  then  then
654   bzip2 -9f /var/log/smage/${PKGNAME}.log   bzip2 -9f /var/log/smage/${PKGNAME}.log
655  else  else
656   [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log   [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log
657  fi  fi
658    
 # for sure  
 unset NOPKGBUILD  
 unset NOSTRIP  
   
659  xtitleclean  xtitleclean

Legend:
Removed from v.1081  
changed lines
  Added in v.1659